﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	import flash.geom.ColorTransform;

	public class Damier extends Sprite
	{
		private var col:Number = 14;
		private var line:Number = 2;
		private var grid:Sprite;
		private var points:Array;
		private var amplitude:Number = 2000;
		private var diametre:Number = 300;
		private var placeLine:Sprite;
		private var colorFill:Number = Math.random()*0xffffff;
		private var colorSquare:Sprite;
		
		private var red:int;
		private var green:int;
		private var blue:int;
		
		private var testClipTransform:ColorTransform;
		
		public function Damier()
		{
			grid = new Sprite();
			addChild(grid);
			grid.x = 100;
			grid.y = -40;
			stage.addEventListener(MouseEvent.CLICK, clickHandler);
			addEventListener(Event.ENTER_FRAME, enterHandler);
		}
		private function clickHandler(e:MouseEvent):void{
			removeEventListener(Event.ENTER_FRAME, enterHandler);
			//removeChild(grid);
			reCreate();
		}
		private function reCreate():void{
			stage.removeEventListener(MouseEvent.CLICK, clickHandler);
			placeLine = new Sprite();
			addChild(placeLine);
			placeLine.x = mouseX;
			placeLine.y = 0;
			placeLine.graphics.lineStyle(1,0xffffff);
			placeLine.graphics.moveTo(0,0);
			placeLine.graphics.lineTo(0,600);
			
			/*colorSquare = new Sprite();
			addChild(colorSquare);
			colorSquare.x = mouseX+3;
			colorSquare.y = mouseY;
			colorSquare.graphics.beginFill(0xffffff)
			colorSquare.graphics.drawRect(0,0,20,20);*/
			
			stage.addEventListener(MouseEvent.CLICK, clickHandler2);
			addEventListener(Event.ENTER_FRAME, lineFollow);
			//addEventListener(Event.ENTER_FRAME, enterHandler);
		}
		private function lineFollow(e:Event):void{
			//placeLine.graphics.clear();
			placeLine.x = mouseX;
			//colorSquare.y = mouseY;
			//colorSquare.x = mouseX - 25;
			
			/*red = 0;
			green = 0;
			blue = 0;
			if(mouseY >= 0 && mouseY <= 199){
				trace("red :  " + mouseY);
			}else if(mouseY >= 200 && mouseY <= 399){
				trace("green :  " + mouseY);
			}else if(mouseY >= 400 && mouseY <= 600){
				trace("blue :  " + mouseY);
			}
			
			testClipTransform=new ColorTransform(0,0,0,1,red,green,blue,0);
	
			colorSquare.transform.colorTransform = testClipTransform; */
			//stage.addEventListener(MouseEvent.CLICK, clickHandler2);
		}
		private function clickHandler2(e:MouseEvent):void{
			colorFill = Math.random()*0xffffff;
			stage.removeEventListener(MouseEvent.CLICK, clickHandler2);
			removeChild(placeLine);
			//removeChild(colorSquare);
			grid = new Sprite();
			addChild(grid);
			grid.x = mouseX;
			grid.y = -40;
			stage.addEventListener(MouseEvent.CLICK, clickHandler);
			addEventListener(Event.ENTER_FRAME, enterHandler);
		}
		private function enterHandler(e:Event):void
		{
			var dist:Number;
			var distx:Number;
			var disty:Number;
			points = new Array();
			for(var i:Number = 0;i<col;i++){
				for(var j:Number = 0; j<line;j++){
					dist = Math.sqrt(Math.pow((j*50-mouseX+grid.x),2) + Math.pow(i*50-mouseY+grid.y,2));
					if(dist<diametre && dist>=10){
						distx= ((j*50)-mouseX+grid.x<0)?-dist:dist;
						disty= ((i*50)-mouseY+grid.y<0)?-dist:dist;
						points.push({"x":j*50+amplitude/distx,"y":i*50+amplitude/disty});
					}else{
						points.push({"x":j*50,"y":i*50});
					}
				}
			}
			grid.graphics.clear();
			//grid.graphics.lineStyle(1,0xffffff);
			for(var k:Number=0;k<points.length;k++){
				grid.graphics.beginFill(colorFill, .3);
				//grid.graphics.drawCircle(points[k].x,points[k].y,10);
				//grid.graphics.endFill();
				if((k+1)%col != 0){
					grid.graphics.moveTo(points[k].x,points[k].y);
					grid.graphics.lineTo(points[k+1].x,points[k+1].y);
					grid.graphics.lineTo(points[k+1].x,points[k].y);
				}
				if(k+col < col*line){
					grid.graphics.moveTo(points[k].x,points[k].y);
					grid.graphics.lineTo(points[k+col].x,points[k+col].y);
					grid.graphics.lineTo(points[k+2].x,points[k+2].y);
				}
			}
		}
	}
}